<template>
  <div class="page--index fill-height">
    <VAppBar :height="74" app flat>
      <VRow dense>
        <VCol cols="12" class="pa-0 mt-4">
          <VTextField
            prepend-inner-icon="mdi-magnify"
            append-icon="mdi-menu-down"
            placeholder="Pesquisar"
            dense
            filled
            rounded
            hide-details
          />
        </VCol>
        <VCol cols="12" class="pa-0 mt-4">
          <VDivider />
        </VCol>
      </VRow>

      <template v-slot:extension>
        <div class="d-flex align-center w-100">
          <VCheckbox
            v-model="allValSelectItems"
            class="mr-3"
            hide-details
            dense
            @change="allSelectItems"
          />
          <VBtn
            :disabled="!isSelectItems"
            :dark="isSelectItems"
            color="indigo"
            depressed
            small
          >
            Atribuir
          </VBtn>
          <VBtn
            :disabled="!isSelectItems"
            :dark="isSelectItems"
            class="mx-3"
            color="teal"
            depressed
            small
            @click="submitArchive"
          >
            Arquivar
          </VBtn>
          <VBtn
            :disabled="!isSelectItems"
            :dark="isSelectItems"
            color="orange darken-3"
            depressed
            small
          >
            Agendar
          </VBtn>
          <VSpacer />
          <VBtn icon small>
            <VIcon>mdi-filter</VIcon>
          </VBtn>
        </div>
      </template>
    </VAppBar>

    <!-- main -->
    <VContainer v-if="!isItems" class="fill-height" fluid>
      <VRow align="center" justify="center">
        <VCol class="text-center">
          <VSkeletonLoader v-if="loading" type="list-item-avatar-three-line" />
          <template v-else>
            <VIcon size="96">mdi-mailbox</VIcon>
            <p class="text-h6">
              Toque no botão contas<br />e abra às mensagens
            </p>
          </template>
        </VCol>
      </VRow>
    </VContainer>
    <template v-else>
      <VList class="pa-0" two-line>
        <VDivider v-if="items.subMenuItems.length > 0" />
        <template v-for="(item, i) in items.subMenuItems">
          <VHover :key="`main-${i}`" v-slot:default="{ hover }">
            <VListItem
              :class="{ 'v-list--active': item.bool }"
              style="min-height: 72px;"
              @click="
                $refs[`checkSelectItem-${i}`][0].$el
                  .querySelector('input')
                  .click()
              "
            >
              <VListItemAction v-show="hover || item.bool" class="mr-7">
                <VCheckbox
                  :ref="`checkSelectItem-${i}`"
                  v-model="item.bool"
                  hide-details
                  @click.stop.prevent
                  @change="changeSelectItem($event, item.id)"
                />
              </VListItemAction>
              <VListItemAvatar
                v-show="!(hover || item.bool)"
                class="justify-center mr-3"
                color="light-green"
              >
                <span class="black--text">{{ item.owner }}</span>
              </VListItemAvatar>

              <VListItemContent>
                <VListItemTitle v-text="item.name" />
                <VListItemSubtitle v-text="item.subject" />
              </VListItemContent>

              <VListItemAction>
                <VListItemActionText>15 min</VListItemActionText>
                <div>
                  <VAvatar
                    v-for="(val, n) in item.users"
                    :key="n"
                    :size="24"
                    color="blue-grey lighten-3"
                  >
                    <span class="black--text text-caption">{{ val }}</span>
                  </VAvatar>
                </div>
              </VListItemAction>
            </VListItem>
          </VHover>

          <VDivider :key="`divider-${i}`" />
        </template>
      </VList>
    </template>
  </div>
</template>

<script lang="ts">
import { Component, Watch, mixins, namespace } from 'nuxt-property-decorator'
import { OnMsg, OnRules } from '@/mixins'
import { errorServer } from '@/data/msg.json'

import { RootState } from '@/store/account'
const accountModule = namespace('account')

@Component
export default class PageIndex extends mixins(OnMsg, OnRules) {
  @accountModule.State
  user!: RootState['user']

  loading = false
  items = {}

  allValSelectItems = false
  selectItems: string[] = []

  get isItems() {
    return Object.keys(this.items).length > 0
  }

  get isSelectItems() {
    return this.selectItems.length > 0
  }

  mounted() {
    this.changeItemEmail(this.user.itemEmail)
  }

  changeSelectItem(bool: boolean, id: string) {
    if (bool) {
      this.selectItems.push(id)
    } else {
      const index = this.selectItems.indexOf(id)
      if (index !== -1) {
        this.$delete(this.selectItems, index)
      }
    }
  }

  allSelectItems() {
    if (this.isItems) {
      Object.values((this.items as any).subMenuItems).forEach((_, i) => {
        ;(this.$refs[`checkSelectItem-${i}`] as any)[0].$el
          .querySelector('input')
          .click()
      })
    }
  }

  submitArchive() {
    const data: any = JSON.parse(JSON.stringify(this.items))
    Object.values(this.selectItems).forEach((el) => {
      const index = data.subMenuItems.findIndex((val: any) => val.id === el)
      this.$delete(data.subMenuItems, index)
    })

    this.selectItems = []
    this.allValSelectItems = false
    this.items = data

    this.$forceUpdate()
    this.onMsg('Arquivados com sucesso!', 'success')
  }

  @Watch('user.itemEmail')
  async changeItemEmail(val: number | null) {
    this.loading = true
    this.selectItems = []

    if (val === null) {
      this.items = {}
    } else {
      try {
        const data = await this.$axios.$get(`items/${val}`)

        Object.values(data.subMenuItems).forEach((el: any) => {
          el.bool = false
        })
        this.items = data
      } catch (err) {
        console.error(err)
        this.onMsg(errorServer, 'error', { timeout: 0 })
      }
    }

    this.loading = false
  }
}
</script>

<style lang="scss">
.page--index {
  .v-list--active {
    &.v-list-item--link::before {
      background-color: #009688 !important;
      opacity: 0.12;
    }
  }
}
</style>
